/***** BEGIN LICENSE BLOCK *****
   - Version: MPL 1.1/GPL 2.0/LGPL 2.1
   -
   - The contents of this file are subject to the Mozilla Public License Version
   - 1.1 (the "License"); you may not use this file except in compliance with
   - the License. You may obtain a copy of the License at
   - http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS IS" basis,
   - WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   - for the specific language governing rights and limitations under the
   - License.
   -
   - The Original Code is "Plain Text To Link".
   -
   - The Initial Developer of the Original Code is Tommaso Beniero.
   - Portions created by the Initial Developer are Copyright (C) 2005 Tommaso Beniero.  
   - All Rights Reserved.
   -
   - Contributor(s): Tommaso Beniero <tommaso DOT beniero AT gmail DOT com>
   -
   - Alternatively, the contents of this file may be used under the terms of
   - either the GNU General Public License Version 2 or later (the "GPL"), or
   - the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   - in which case the provisions of the GPL or the LGPL are applicable instead
   - of those above. If you wish to allow use of your version of this file only
   - under the terms of either the GPL or the LGPL, and not to allow others to
   - use your version of this file under the terms of the MPL, indicate your
   - decision by deleting the provisions above and replace them with the notice
   - and other provisions required by the LGPL or the GPL. If you do not delete
   - the provisions above, a recipient may use your version of this file under
   - the terms of any one of the MPL, the GPL or the LGPL.
   -
   - 
***** END LICENSE BLOCK *****/

/* Thanks to Ted Mielczarek for the functions unmangleURL and fixURL

/*
 * Copyright (c) 2001-2002  Ted Mielczarek
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

var myMenuItems = new Array("divisor", "open_with_pttl", "save_with_pttl", "pttl_menu", "pttl_menupopup", "open_here", "open_window", "open_tab", "add_bookmark", "divisor1", "send_email_to", "send_text_in_email", "divisor2", "search_google_groups_window", "search_google_groups_tab", "divisor3", "translate", "divisor4", "save", "append");  
var strings;
var fileSavedPath;

// initialize function

function init() {
	
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("pttl.");
    var menu = document.getElementById("contentAreaContextMenu");
    strings = document.getElementById("pttlStrings");
    
    try{
    	var selRadio = prefs.getIntPref("open-type");
    }catch(ex){prefs.setIntPref("open-type",0);}
	try{
    	var selDir = prefs.getCharPref("save-directory-default");
    }catch(ex){prefs.setCharPref("save-directory-default","");}
	try{
    	var selExt = prefs.getCharPref("save-extension-default");
    }catch(ex){prefs.setCharPref("save-extension-default","");}

	var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
    observerService.addObserver(pttlSliderClickObserver, "alertclickcallback", false);
    menu.addEventListener("popupshowing",verSelText,false);  

}

// Definition of the slider text click observer

var pttlSliderClickObserver = {

	observe: function (subject, topic, state){
    
    	if (topic == "alertclickcallback"){ 
			getBrowser().loadURI(fileSavedPath);
     }
    
    }

}

// show a slider pane with the string msg

function pttlSlider(msg) {
	
	try {
     var alertService = Components.classes["@mozilla.org/alerts-service;1"].getService(Components.interfaces.nsIAlertsService);
		alertService.showAlertNotification("chrome://pttl/skin/pttl.png", "Plain Text To Link", msg, true, "", pttlSliderClickObserver);
	} catch (ex) {}
    
}

// show options in Tools menu

function showPttlOptionDialog() {

	window.openDialog("chrome://pttl/content/pttlOptions.xul", "pttl-dialog", "centerscreen,chrome,modal", "add");
    
}

// show warning for sendTextInEmail() function

function saveWarning() {
	
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("pttl.");
	if (prefs.getCharPref("save-directory-default").length == 0) {
    	window.openDialog("chrome://pttl/content/pttlSaveWarning.xul", "pttl-dialog", "centerscreen,chrome,modal", "add");
     return false;
    }
    else return true;
    
}

// it allows to obtain a string representing the selected text on the screen

function getString() {
    
    var hlText = "";

	var focusedWindow = document.commandDispatcher.focusedWindow;
	hlText = focusedWindow.getSelection.call(focusedWindow);
   	hlText = hlText.toString();
	hlText = manipulateString(hlText);

    return hlText;

}

// it checks whether there's selected text or not. If it's true, the menu appears, otherwise it doesn't	

function verSelText() {

	var isTextSelection = false;
	if(gContextMenu) isTextSelection = gContextMenu.isTextSelected;
	for(var i=0; i<myMenuItems.length; i++) {
		var menuitem = document.getElementById(myMenuItems[i]);
		if(menuitem) {
			menuitem.hidden = !isTextSelection;
		}
	}
	
}

// default open action

function openDefault(){
	
    var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("pttl.");
    var selRadio = prefs.getIntPref("open-type");
    openUrl(selRadio);
    
}

// default save action

function saveDefault(){
    
    var text = getString();
    if (text == ""){
    	return;
    }
    else if(saveWarning()) {
    	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("pttl.");
     var stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
     var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
     var selDir = prefs.getCharPref("save-directory-default");
     var selExt = prefs.getCharPref("save-extension-default");
     var pttlDiv = getPttlDivisor();
     var fileName = getPttlTime() + selExt;
     file.initWithPath(selDir);
     file.append(fileName);
     file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0664);
     
     fileSavedPath = file.path;
     
     stream.init(file, 0x02, 0664, null);
    	stream.write(pttlDiv, pttlDiv.length);
     stream.write(text,text.length);
     stream.close();

     pttlSlider(fileName + " - " + strings.getString("statusBarMsg"));
     
    }

    
}

// it allows to add the selected link in Firefox Bookmarks

function addBookmark() {
	
	var docTitle = document.title; 
	var URLAddress = getString();
    if (URLAddress == ""){
    	return;
    }
	var browser = getBrowser();
	URLAddress = fixURL(unmangleURL(URLAddress));		
	openDialog("chrome://browser/content/bookmarks/addBookmark.xul", "", "centerscreen,chrome,dialog=no,resizable=yes", URLAddress, URLAddress);

}

// it allows to send a email to the selected address

function sendEmailTo() {
		
	var EmailAddr=getString();
    if (EmailAddr == ""){
    	return;
    }
	var browser=getBrowser();
	EmailAddr=manipulateEmail(EmailAddr);
	browser.loadURI("mailto:"+EmailAddr);

}

// it allows to send selected text in a email

function sendTextInEmail() {
		
    var text=getString();
    if (text == ""){
    	return;
    }
    text=manipulateText(text);
	var browser=getBrowser();
	browser.loadURI("mailto:?subject=&body="+text);

}

// it allows to translate selected text from English to the locale language

function translateFromEnglish() {

	var UA = navigator.userAgent;
	var text = getString();
    if (text == ""){
    	return;
    }
	var browser=getBrowser();
	if(UA.search("en") != -1) {
		alert("This function is reserved only for non-English users");
	}
	else if(UA.search("it") != -1) {
		browser.addTab("http://babelfish.altavista.com/babelfish/tr?doit=done&urltext="+text+"&lp=en_it");
	}
	else if(UA.search("de") != -1) {
		browser.addTab("http://babelfish.altavista.com/babelfish/tr?doit=done&urltext="+text+"&lp=en_de");
	}
	else if(UA.search("es-ES") != -1) {
		browser.addTab("http://babelfish.altavista.com/babelfish/tr?doit=done&urltext="+text+"&lp=en_es");
	}
	else if(UA.search("fr") != -1) {
		browser.addTab("http://babelfish.altavista.com/babelfish/tr?doit=done&urltext="+text+"&lp=en_fr");
	}
    else if(UA.search("ru") != -1) {
		browser.addTab("http://babelfish.altavista.com/babelfish/tr?doit=done&urltext="+text+"&lp=en_ru");
	}
	else alert("Sorry, but this function is not present in your language yet.\nContact me at tommaso.beniero@gmail.com\nand if you want you can help me translating it in your language");

}

// it allows to open the selected URL

function openUrl(n) {
	
	var URLAddress = getString();
    if (URLAddress == ""){
    	return;
    }
    else {
     	URLAddress = fixURL(this.unmangleURL(URLAddress));		
     	switch(n) {
     		// open the selected URL in the current window
     		case 0:	{
     			getBrowser().loadURI(URLAddress);
     			break;
     		}
     		// open the selected URL in a new window
     		case 1:	{
     			window.open(URLAddress);
     			break;
     		}
     		// open the selected URL in a new unselected tab
     		case 2:	{
     			getBrowser().addTab(URLAddress);
     			break;
     		}
          // open the selected URL in a new selected tab
     		case 3:	{
     			var tab = getBrowser().addTab(URLAddress);
     			getBrowser().selectedTab=tab;
     			break;
     		}
	
			}
	}

}

// it allows to search the selected text in Google Groups

function searchGoogleGroups(n) {

	var searchText = getString();
    if (searchText == ""){
    	return;
    }
	switch(n) {
		case 0:	{
			window.open("http://groups.google.com/groups?q="+searchText);		
			break;
		}
		case 1:	{
			var browser=getBrowser();
			browser.addTab("http://groups.google.com/groups?q="+searchText);
			break;
		}
	}

}

// it allows to save selected text to a file

function pttlSave() {
	 
	var text = getString();
    if (text == ""){
    	return;
    }
	var filePick = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	var stream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	var winTitle = strings.getString("saveWinTitle");
    var pttlDiv = getPttlDivisor();
    
    filePick.init(window, winTitle, filePick.modeSave);
	filePick.appendFilters(filePick.filterText);

	if (filePick.show() != filePick.returnCancel) {
		if (filePick.file.exists()) filePick.file.remove(true);
		filePick.file.create(filePick.file.NORMAL_FILE_TYPE, 0666);
     
     fileSavedPath = filePick.file.path;
     
     stream.init(filePick.file, 0x02, 0664, null);
		stream.write(pttlDiv, pttlDiv.length);
		stream.write(text, text.length);
		stream.close();
		   
		pttlSlider(getPttlFileName(filePick.file.path) + " - " + strings.getString("statusBarMsg"));
    
	}
    
}

// it allows to append selected text to a previous PTTL file saved

function pttlAppend() {
	
    var UA = navigator.userAgent;
	var filePick = Components.classes["@mozilla.org/filepicker;1"].createInstance(Components.interfaces.nsIFilePicker);
	var streamWr = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	var winTitle = strings.getString("appendWinTitle");
	var text = getString();
    if (text == ""){
    	return;
    }
    var pttlDiv = getPttlDivisor();
	
	filePick.init(window, winTitle, filePick.modeOpen);
	filePick.appendFilters(filePick.filterText);

	if (filePick.show() != filePick.returnCancel) {
     
     fileSavedPath = filePick.file.path;
     
     streamWr.init(filePick.file, 0x02 | 0x10, 0664, 0);
     streamWr.write("\n\n\n"+pttlDiv, ("\n\n\n"+pttlDiv).length);
     streamWr.write(text, text.length);
     streamWr.close();
     
     pttlSlider(getPttlFileName(filePick.file.path) + " - Append ok");
		
	}
	
}

// it removes the observer at the extension unload

function unloadDownloadObserver(){

	var observerService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	observerService.removeObserver(pttlSliderClickObserver, "alertclickcallback");

}

window.addEventListener("load", init, false);
window.addEventListener("unload",unloadDownloadObserver,false);